VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "DB_GlobalWorks"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private data_ As Excel.Worksheet
Private projects_ As DB_CachedProjects

Public Function Init(target As Excel.Worksheet, iProjects As DB_CachedProjects)
  Set data_ = target
  Set projects_ = iProjects
End Function

Public Function IBegin() As IteratorGlobalWork
  Set IBegin = New IteratorGlobalWork
  Call IBegin.Init(data_)
End Function

Public Function ILast() As IteratorGlobalWork
  Set ILast = New IteratorGlobalWork
  Call ILast.Init(data_)
  Call ILast.GoLast
End Function

Public Function INew() As IteratorGlobalWork
  Set INew = New IteratorGlobalWork
  Call INew.Init(data_)
  Call INew.GoLast
  Call INew.Increment
End Function

Public Function Clear()
  Call data_.UsedRange.Offset(1).ClearContents
End Function

Public Function ReloadDataFor(iWorker As IteratorWorker, iReport As Excel.Workbook, nStartDate&)
  Dim sWorkerID$: sWorkerID = iWorker.WorkerID
  Call RemoveDataFor(sWorkerID)
  
  Dim iData As DB_WorkerData: Set iData = AccessWorkerData(iReport)
  Dim iWork As IteratorWork: Set iWork = iData.IBegin
  Call iWork.GoUntil(nStartDate)
  
  Dim dHours As Double: dHours = 0
  Dim out As IteratorGlobalWork: Set out = INew
  Do While Not iWork.IsDone
    Dim dDuration As Double: dDuration = iWork.Duration
    If dDuration = 0 Then _
      GoTo NEXT_WORK
      
    dHours = dHours + dDuration
    With out
      .Category = projects_.GetProjectCategory(iWork.Project)
      .DDate = iWork.DDate
      .Description = iWork.Description
      .Duration = dDuration
      .Project = iWork.Project
      .WorkerID = sWorkerID
      .WorkType = iWork.WorkType
      .Year = VBA.Year(iWork.DDate)
    End With
    Call out.Increment
    
NEXT_WORK:
    Call iWork.Increment
  Loop
  
  iWorker.Hours = dHours
End Function

' ========
Private Function RemoveDataFor(target$)
  Dim iWork As IteratorGlobalWork: Set iWork = IBegin
  Do While Not iWork.IsDone
    If iWork.WorkerID = target Then
      Call iWork.RemoveRow
    Else
      Call iWork.Increment
    End If
  Loop
End Function
