Attribute VB_Name = "DataAccess"
Option Private Module
Option Explicit

Public Function GetStartDate() As Long
  GetStartDate = ThisWorkbook.Names(CELL_DATE_START).RefersToRange
End Function

Public Function AccessWorkers() As DB_Workers
  Static s_Workers As DB_Workers
  
  If s_Workers Is Nothing Then
    Set s_Workers = New DB_Workers
    Call s_Workers.Init(ThisWorkbook.Worksheets(SHEET_WORKERS))
  End If
  
  Set AccessWorkers = s_Workers
End Function

Public Function AccessWorkerData(iSource As Excel.Workbook) As DB_WorkerData
  Set AccessWorkerData = New DB_WorkerData
  Call AccessWorkerData.Init(iSource)
End Function

Public Function AccessGlobalWorks() As DB_GlobalWorks
  Static s_Data As DB_GlobalWorks
  
  If s_Data Is Nothing Then
    Set s_Data = New DB_GlobalWorks
    Call s_Data.Init(ThisWorkbook.Worksheets(SHEET_DATA), AccessProjects)
  End If
  
  Set AccessGlobalWorks = s_Data
End Function

Public Function AccessProjects() As DB_CachedProjects
  Static s_Projects As DB_CachedProjects
  
  If s_Projects Is Nothing Then
    Dim xlApp As New API_XLWrapper: Call xlApp.CreateApplication(bIsVisible:=False)
    Dim iSource As Excel.Workbook: Set iSource = xlApp.OpenDocument(PATH_PROJECTS, bReadOnly:=True)
    If iSource Is Nothing Then
      Call UserInteraction.ShowMessage(EM_CANNOT_ACCESS_PROJECTS, PATH_PROJECTS)
      Exit Function
    End If
  
    Set s_Projects = New DB_CachedProjects
    Call s_Projects.Reload(iSource)
    
    Call xlApp.ReleaseDocument
    Call xlApp.ReleaseApplication
  End If
  
  Set AccessProjects = s_Projects
End Function
