VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "IteratorGlobalWork"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public row_ As Long
Private data_ As Excel.Worksheet

Public Sub Init(target As Excel.Worksheet, Optional tRow& = FIRST_ROW)
  Set data_ = target
  row_ = tRow
End Sub

Public Function Increment(Optional inc& = 1)
  If row_ + inc > 0 Then _
    row_ = row_ + inc
End Function

Public Function GoFirst()
  row_ = FIRST_ROW
End Function

Public Function GoLast()
  row_ = data_.Columns(S_GD_WORKER_ID).Find(vbNullString, LookAt:=xlWhole).Row - 1
End Function

Public Function IsDone() As Boolean
  IsDone = data_.Cells(row_, S_GD_WORKER_ID) = vbNullString
End Function

Public Function RemoveRow()
  Call data_.Rows(row_).Delete
End Function

'===== Propertiy Get =====
Public Property Get WorkerID() As String
  WorkerID = data_.Cells(row_, S_GD_WORKER_ID)
End Property

Public Property Get Year() As Integer
  Year = data_.Cells(row_, S_GD_YEAR)
End Property

Public Property Get DDate() As Long
  DDate = data_.Cells(row_, S_GD_DATE)
End Property

Public Property Get Category() As TProjectCategory
  Category = CCStringToCategory(data_.Cells(row_, S_GD_CATEGORY))
End Property

Public Property Get Project() As String
  Project = data_.Cells(row_, S_GD_PROJECT)
End Property

Public Property Get Duration() As Double
  Duration = data_.Cells(row_, S_GD_HOURS)
End Property

Public Property Get WorkType() As String
  WorkType = data_.Cells(row_, S_GD_WORK_TYPE)
End Property

Public Property Get Description() As String
  Description = data_.Cells(row_, S_GD_DESCRIPTION)
End Property

' ==== Property Let ====
Public Property Let WorkerID(newVal$)
  data_.Cells(row_, S_GD_WORKER_ID) = newVal
End Property

Public Property Let Year(newVal%)
  data_.Cells(row_, S_GD_YEAR) = newVal
End Property

Public Property Let DDate(newVal&)
  data_.Cells(row_, S_GD_DATE) = newVal
End Property

Public Property Let Category(newVal As TProjectCategory)
  data_.Cells(row_, S_GD_CATEGORY) = CCCategoryToString(newVal)
End Property

Public Property Let Project(newVal$)
  data_.Cells(row_, S_GD_PROJECT) = newVal
End Property

Public Property Let Duration(newVal As Double)
  data_.Cells(row_, S_GD_HOURS) = newVal
End Property

Public Property Let WorkType(newVal$)
  data_.Cells(row_, S_GD_WORK_TYPE) = newVal
End Property

Public Property Let Description(newVal$)
  data_.Cells(row_, S_GD_DESCRIPTION) = newVal
End Property
