Attribute VB_Name = "MainImpl"
Option Private Module
Option Explicit

Public Function ClearAll()
  Call ThisWorkbook.Worksheets(SHEET_DATA).UsedRange.Offset(1).ClearContents
  Call ThisWorkbook.Worksheets(SHEET_WORKERS).UsedRange.Offset(1).ClearContents
  Call UpdatePivots
End Function

Public Function UpdatePivots()
  Dim iPivot As Excel.PivotTable
  Dim iSheet As Excel.Worksheet
  For Each iSheet In ThisWorkbook.Sheets
    For Each iPivot In iSheet.PivotTables
      On Error Resume Next
      With iPivot
        .RefreshTable
        .Update
      End With
      On Error GoTo 0
    Next iPivot
  Next iSheet
End Function

Public Function PromptInputWorker(iWorkers As DB_Workers) As ItemInputWorker
  With CreateWorkerDlg
    Call .Init(iWorkers)
    Call .Show
    If .isCanceled_ Then _
      Exit Function
    Set PromptInputWorker = .GetUserInput
  End With
End Function

Public Function PromptWorkerID(iWorkers As DB_Workers) As String
  Dim sInput$: sInput = UserInteraction.PromptInput(" ", " ")
  If sInput = vbNullString Then _
    Exit Function
  If iWorkers.Contains(sInput) Then
    PromptWorkerID = sInput
  Else
    Call UserInteraction.ShowMessage(EM_INVALID_WORKER, sInput)
  End If
End Function

Public Function ReloadWorker(iWorker As IteratorWorker, iData As DB_GlobalWorks, nStartDate&) As Boolean
  ReloadWorker = False
  
  Dim sPath$: sPath = iWorker.ReportPath
  Dim fso As New Scripting.FileSystemObject
  If Not fso.FileExists(sPath) Then
    Call UserInteraction.ShowMessage(EM_MISSING_REPORT_FILE, sPath)
    Exit Function
  End If
  
  Dim xlApp As New API_XLWrapper: Call xlApp.SetApplication(ThisWorkbook.Application)
  Dim iReport As Excel.Workbook: Set iReport = xlApp.OpenDocument(sPath, bReadOnly:=True)
  If iReport Is Nothing Then _
    Exit Function
    
  ReloadWorker = ValidateReport(iReport)
  If ReloadWorker Then
    Call iData.ReloadDataFor(iWorker, iReport, nStartDate)
  Else
    Call UserInteraction.ShowMessage(EM_REPORT_INVALID, sPath)
  End If
  Call xlApp.ReleaseDocument
End Function

