Attribute VB_Name = "z_UIMessages"
' Messaging module
Option Private Module
Option Explicit

Public Enum MsgCode
  MSG_OK = 0
  
  EM_INVALID_WORKER
  EM_WORKER_ALREADY_EXISTS
  EM_WORKER_ALREADY_REMOVED
  EM_CANNOT_ACCESS_PROJECTS
  EM_MISSING_REPORT_FILE
  EM_REPORT_INVALID

  IM_ADD_WORKER_OK
  IM_REMOVE_WORKER_OK
  IM_RELOAD_WORKER_OK
  IM_RELOAD_ALL_OK

 ' QM_CODE_DELETE_CONFIRM
End Enum

Private g_UI As API_UserInteraction

Public Function UserInteraction() As API_UserInteraction
  If g_UI Is Nothing Then _
    Set g_UI = New API_UserInteraction
  Set UserInteraction = g_UI
End Function

Public Function SetUserInteraction(newUI As API_UserInteraction)
  Set g_UI = newUI
End Function

Public Function UIShowMessage(theCode As MsgCode, ParamArray params() As Variant)
  Dim unwrapped As Variant: unwrapped = params
  unwrapped = FixForwardedParams(unwrapped)
  
  Select Case theCode
  Case EM_INVALID_WORKER:             Call MsgBox(Fmt("   : {1}", unwrapped), vbExclamation)
  Case EM_WORKER_ALREADY_EXISTS:      Call MsgBox(Fmt("   : {1}", unwrapped), vbExclamation)
  Case EM_WORKER_ALREADY_REMOVED:     Call MsgBox(Fmt("   : {1}", unwrapped), vbExclamation)
  Case EM_CANNOT_ACCESS_PROJECTS:     Call MsgBox(Fmt("      " & vbNewLine & "{1}", unwrapped), vbExclamation)
  Case EM_MISSING_REPORT_FILE:        Call MsgBox(Fmt("    : {1}", unwrapped), vbExclamation)
  Case EM_REPORT_INVALID:             Call MsgBox(Fmt("    : {1}", unwrapped), vbExclamation)
      
  Case IM_ADD_WORKER_OK:              Call MsgBox(Fmt("  : {1}", unwrapped), vbInformation)
  Case IM_REMOVE_WORKER_OK:           Call MsgBox(Fmt(" : {1}", unwrapped), vbInformation)
  Case IM_RELOAD_WORKER_OK:           Call MsgBox("   ", vbInformation)
  Case IM_RELOAD_ALL_OK:             Call MsgBox("   ", vbInformation)
      
  Case Else:                          Call MsgBox("Invalid message code", vbCritical)
  End Select
End Function

Public Function UIAskQuestion(theCode As MsgCode, ParamArray params() As Variant) As Boolean
  Dim unwrapped As Variant: unwrapped = params
  unwrapped = FixForwardedParams(unwrapped)
  
  Dim answer&: answer = vbNo
  Select Case theCode
 ' Case QM_CODE_DELETE_CONFIRM
 '   answer = MsgBox("Are you sure you want to delete ALL macros from target file?", vbYesNo + vbQuestion)
    
  Case Else
    Call MsgBox("Invalid message code", vbCritical)
  End Select
  UIAskQuestion = answer = vbYes
End Function
