VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "DB_Projects"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private data_ As Excel.Worksheet

Public Function Init(iData As Excel.Worksheet)
  Set data_ = iData
End Function

Public Property Get Data() As Excel.Worksheet
  Set Data = data_
End Property

Public Property Get Count() As Long
  Count = ILast.row_ - IBegin.row_ + 1
End Property

Public Function IBegin() As IteratorProject
  Set IBegin = New IteratorProject
  Call IBegin.Init(data_)
End Function

Public Function ILast() As IteratorProject
  Set ILast = New IteratorProject
  Call ILast.Init(data_)
  Call ILast.GoLast
End Function

Public Function INew() As IteratorProject
  Set INew = New IteratorProject
  Call INew.Init(data_)
  Call INew.GoLast
  Call INew.Increment
End Function

Public Function UpdateSorting()
  Call data_.Columns("A:E").Sort(Key1:=data_.Cells(1, S_P_PERMANENT), Order1:=xlDescending, _
                            Key2:=data_.Cells(1, S_P_TYPE), Order2:=xlDescending, _
                            Key3:=data_.Cells(1, S_P_NAME), Order3:=xlDescending)
End Function

Public Function DumpData() As String()
  Dim nCount&: nCount = Count
  If nCount = 0 Then _
    Exit Function

  Dim iDump() As String
  ReDim iDump(1 To nCount, ProjectTransferStruct.[_First] To ProjectTransferStruct.[_Last])
  Dim iter As IteratorProject: Set iter = IBegin
  Dim nItem&: nItem = 1
  Do While Not iter.IsDone
    iDump(nItem, S_TP_TYPE) = iter.PCategory
    iDump(nItem, S_TP_NAME) = iter.Project
    iDump(nItem, S_TP_MANAGER) = iter.Manager
    Call iter.Increment
    nItem = nItem + 1
  Loop

  DumpData = iDump
End Function

