VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "DB_WorkerData"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private source_ As Excel.Workbook
Private data_ As Excel.Worksheet

Public Function Init(iSource As Excel.Workbook)
  Set source_ = iSource
  Set data_ = source_.Sheets(WORKER_SHEET_DATA)
End Function

Public Property Get WorkerID() As String
  WorkerID = source_.Names(CELL_WORKER_ID).RefersToRange
End Property

Public Property Get WorkerName() As String
  WorkerName = source_.Names(CELL_WORKER_NAME).RefersToRange
End Property

Public Function IBegin() As IteratorWork
  Set IBegin = New IteratorWork
  Call IBegin.Init(data_)
End Function

Public Function ILast() As IteratorWork
  Set ILast = New IteratorWork
  Call ILast.Init(data_)
  Call ILast.GoLast
End Function

Public Function INew() As IteratorWork
  Set INew = New IteratorWork
  Call INew.Init(data_)
  Call INew.GoLast
  Call INew.Increment
End Function

' ====== Actions =======
Public Function FixDataGroups()
  On Error Resume Next
  Call data_.UsedRange.Rows.Ungroup
  Call data_.UsedRange.Rows.ClearOutline
  On Error GoTo 0

  Dim nRow&: nRow = WORKER_FIRST_ROW
  Dim nLevel&
  Do
    Dim sText$: sText = data_.Cells(nRow, S_W_DATE)
    If sText = vbNullString Then _
      Exit Function
    If sText Like ":*" Then
      nLevel = 1
    ElseIf sText Like ":*" Then
      nLevel = 2
    Else
      nLevel = 3
    End If
    data_.Rows(nRow).OutlineLevel = nLevel

    nRow = nRow + 1
  Loop
End Function

Public Function DeleteHolidays() As Long
  Dim iWork As IteratorWork: Set iWork = IBegin
  Do While Not iWork.IsDone
    If iWork.Project = PROJECT_HOLIDAYS Then
      Call iWork.RemoveRow
      DeleteHolidays = DeleteHolidays + 1
    Else
      Call iWork.Increment
    End If
  Loop
End Function

Public Function CreateYear(nYear%)
  Dim iOut As IteratorWork: Set iOut = INew
  Dim nDate&: nDate = VBA.DateSerial(nYear, 1, 1)
  Call iOut.AddYear(nYear)
  Do While VBA.Year(nDate) = nYear
    If VBA.Day(nDate) = 1 Then _
      Call iOut.AddMonth(VBA.Month(nDate))
    Call iOut.AddDay(nDate, VBA.Weekday(nDate, vbMonday) > 5)
    nDate = nDate + 1
  Loop
End Function

Public Function ImportYear(iSource As Excel.Worksheet)
  Dim iOut As IteratorWork: Set iOut = INew
  Dim nRow&: nRow = 1
  Dim nDate&: nDate = iSource.Cells(nRow, 1)
  Dim nYear%: nYear = VBA.Year(nDate)
  Call iOut.AddYear(nYear)
  Do While VBA.Year(nDate) = nYear
    If VBA.Day(nDate) = 1 Then _
      Call iOut.AddMonth(VBA.Month(nDate))
    Call iOut.AddDay(nDate, iSource.Cells(nRow, 2) = PROJECT_HOLIDAYS)
    nRow = nRow + 1
    nDate = iSource.Cells(nRow, 1)
  Loop
End Function
