VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "IteratorProject"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public row_ As Long
Private data_ As Excel.Worksheet

Public Sub Init(target As Excel.Worksheet, Optional nRow& = FIRST_ROW)
  Set data_ = target
  row_ = nRow
End Sub

Public Function Increment(Optional inc& = 1)
  If row_ + inc > 0 Then _
    row_ = row_ + inc
End Function

Public Function GoFirst()
  row_ = FIRST_ROW
End Function

Public Function GoLast()
  row_ = data_.Columns(S_P_NAME).Find(vbNullString, LookAt:=xlWhole).Row - 1
End Function

Public Function IsDone() As Boolean
  IsDone = data_.Cells(row_, S_P_NAME) = vbNullString
End Function

Public Function RemoveRow()
  Call data_.Rows(row_).Delete
End Function

Public Function ImportFrom(iAnother As IteratorProject)
  PCategory = iAnother.PCategory
  Project = iAnother.Project
  Manager = iAnother.Manager
  DateFinished = iAnother.DateFinished
End Function

'===== Propertiy Get =====
Public Property Get PCategory() As TProjectCategory
  PCategory = data_.Cells(row_, S_P_TYPE)
End Property

Public Property Get Project() As String
  Project = data_.Cells(row_, S_P_NAME)
End Property

Public Property Get Manager() As String
  Manager = data_.Cells(row_, S_P_MANAGER)
End Property

Public Property Get DateFinished() As Long
  DateFinished = data_.Cells(row_, S_P_DATE)
End Property

Public Property Get IsPermanent() As Boolean
  IsPermanent = data_.Cells(row_, S_P_PERMANENT) = 1
End Property

' ==== Property Let ====
Public Property Let PCategory(newVal As TProjectCategory)
  data_.Cells(row_, S_P_TYPE) = newVal
End Property

Public Property Let Project(newVal$)
  data_.Cells(row_, S_P_NAME) = newVal
End Property

Public Property Let Manager(newVal$)
  data_.Cells(row_, S_P_MANAGER) = newVal
End Property

Public Property Let DateFinished(newVal&)
  If newVal > 0 Then _
    data_.Cells(row_, S_P_DATE) = newVal
End Property

