Attribute VB_Name = "MainImpl"
Option Private Module
Option Explicit

Public Function ScanProjects() As Scripting.Dictionary
  Dim iProjects As Scripting.Dictionary
  Set iProjects = CCListProjects(T_PRJ_INCOME)
  Call DictionaryAbsorbShallow(iProjects, CCListProjects(T_PRJ_OUTCOME))
  Call DictionaryAbsorbShallow(iProjects, CCListProjects(T_PRJ_LEAD_ACTIVE))
  Call DictionaryAbsorbShallow(iProjects, CCListProjects(T_PRJ_LEAD_TENTATIVE))
  Set ScanProjects = iProjects
End Function

Public Function UpdateProjects(iActive As DB_Projects, iArchive As DB_Projects, iProjects As Scripting.Dictionary)
  Call UpdateArchive(iActive, iArchive, iProjects)
  Call AddNewActive(iActive, iProjects)
  Call iActive.UpdateSorting
  Call iArchive.UpdateSorting
End Function

' =====
Private Function UpdateArchive(iActive As DB_Projects, iArchive As DB_Projects, iProjects As Scripting.Dictionary)
  Dim iOut As IteratorProject: Set iOut = iArchive.INew
  Dim iProj As IteratorProject: Set iProj = iActive.IBegin
  Do While Not iProj.IsDone
    If iProj.IsPermanent Then
      Call iProj.Increment
    ElseIf iProjects.Exists(iProj.Project) Then
      iProj.PCategory = iProjects(iProj.Project)
      Call iProjects.Remove(iProj.Project)
      Call iProj.Increment
    Else
      Call iOut.ImportFrom(iProj)
      Call iOut.Increment
      Call iProj.RemoveRow
    End If
  Loop
End Function

Private Function AddNewActive(iActive As DB_Projects, iProjects As Scripting.Dictionary)
  Dim iOut As IteratorProject: Set iOut = iActive.INew
  Dim aKey As Variant
  For Each aKey In iProjects
    iOut.Project = CStr(aKey)
    iOut.PCategory = iProjects(aKey)
    Call iOut.Increment
  Next aKey
End Function
