Attribute VB_Name = "DataAccess"
Option Private Module
Option Explicit

Public Function AccessWorker(iSource As Excel.Workbook) As DB_WorkerData
  Set AccessWorker = New DB_WorkerData
  Call AccessWorker.Init(iSource)
End Function

Public Function AccessWorkTypes(iSource As Excel.Workbook) As Scripting.Dictionary
  Dim iWorks As New Scripting.Dictionary
  Dim iSheet As Excel.Worksheet
  Dim iTable As Excel.ListObject: Set iTable = iSource.Sheets(SHEET_OPTIONS).ListObjects(TABLE_WORKS)
  Dim nRow&
  For nRow = 1 To iTable.ListRows.Count
    Dim sWorkID$: sWorkID = iTable.ListRows(nRow).Range.Cells(1, 1)
    Dim sWorkInfo$: sWorkInfo = iTable.ListRows(nRow).Range.Cells(1, 2)
    Call iWorks.Add(sWorkID, sWorkInfo)
  Next nRow
  Set AccessWorkTypes = iWorks
End Function

Public Function AccessProjects() As DB_CachedProjects
  Static s_Projects As DB_CachedProjects
  
  If s_Projects Is Nothing Then
    Dim xlApp As New API_XLWrapper: Call xlApp.CreateApplication(bIsVisible:=False)
    Dim iSource As Excel.Workbook: Set iSource = xlApp.OpenDocument(PATH_PROJECTS, bReadOnly:=True)
    If iSource Is Nothing Then
      Call UserInteraction.ShowMessage(EM_CANNOT_ACCESS_PROJECTS, PATH_PROJECTS)
      Exit Function
    End If
  
    Set s_Projects = New DB_CachedProjects
    Call s_Projects.Reload(iSource)
    
    Call xlApp.ReleaseDocument
    Call xlApp.ReleaseApplication
  End If
  
  Set AccessProjects = s_Projects
End Function
