Attribute VB_Name = "MainImpl"
Option Explicit
Option Private Module

Public Function GetActiveDay(iWhere As Excel.Workbook) As Long
  GetActiveDay = VBA.Int(VBA.Now())
  If iWhere.ActiveSheet.Name <> WORKER_SHEET_DATA Then _
    Exit Function
  Dim nRow&: nRow = iWhere.Application.Selection.Cells(1, 1).Row
  On Error Resume Next
  GetActiveDay = iWhere.Sheets(WORKER_SHEET_DATA).Cells(nRow, S_W_DATE)
  On Error GoTo 0
End Function

Public Function PromptYear() As Integer
  With CRD_NewYear
    Call .Init
    Call .Show
    If .isCanceled_ Then _
      Exit Function
    PromptYear = .ComboBox1.Value
  End With
  Call Unload(CRD_NewYear)
End Function

Public Function PromptWorkTypeID(iData As Scripting.Dictionary) As String
  With CRD_WorkList
    Call .Init(iData)
    Call .Show
    If .isCanceled_ Then _
      Exit Function
    PromptWorkTypeID = .GetSelectedID
  End With
End Function

Public Function PromptActiveProject(iData As DB_CachedProjects) As String
  With CRD_ProjectList
    Call .Init(iData)
    Call .Show
    If .isCanceled_ Then _
      Exit Function
    PromptActiveProject = .GetSelectedID
  End With
End Function

Public Function GenerateDayDescription(nDay&, iData As DB_WorkerData) As String
  Dim sText$
  Dim iWork As IteratorWork: Set iWork = iData.IBegin
  Call iWork.GoUntil(nDay)
  Do While Not iWork.IsDone
    If iWork.DDate <> nDay Then _
      Exit Do
    
    If iWork.Duration <> 0 Then
      If sText <> vbNullString Then _
        sText = sText & vbNewLine
      sText = sText & Fmt("{1} - {2} - {3}", iWork.Project, iWork.Duration, iWork.Description)
    End If
    Call iWork.Increment
  Loop
  GenerateDayDescription = sText
End Function

Public Function CreateDailyMessage(nDate&, sDescription$) As Boolean
  CreateDailyMessage = False
  On Error GoTo RETURN_FALSE
  
  Dim iDailyMsg As Outlook.MailItem: Set iDailyMsg = Outlook.Application.CreateItem(olMailItem)
  With iDailyMsg
    .To = ZAK_MAIL
    .Subject = VBA.Format(nDate, "yyyymmdd") & " " & DAILY_REPORT_SUBJECT
    .Body = VBA.Format(nDate, "yyyymmdd") & vbNewLine & vbNewLine & sDescription
    .Display
  End With
    
  CreateDailyMessage = True
  Exit Function
RETURN_FALSE:
  On Error GoTo 0
End Function

Public Function ReloadPivotData(iOut As Excel.Worksheet, iData As DB_WorkerData, iProjects As DB_CachedProjects)
  Call iOut.UsedRange.Offset(1).ClearContents
  
  Dim nRow&: nRow = PIVOT_FIRST_ROW
  Dim iWork As IteratorWork: Set iWork = iData.IBegin
  Do While Not iWork.IsDone
    If iWork.Duration = 0 Then _
      GoTo NEXT_WORK
      
    With iOut
      .Cells(nRow, S_P_DATE) = iWork.DDate
      .Cells(nRow, S_P_YEAR) = VBA.Year(iWork.DDate)
      .Cells(nRow, S_P_IO) = CCCategoryToString(iProjects.GetProjectCategory(iWork.Project))
      .Cells(nRow, S_P_PROJECT) = iWork.Project
      .Cells(nRow, S_P_HOURS) = iWork.Duration
      .Cells(nRow, S_P_WORK_TYPE) = iWork.WorkType
      .Cells(nRow, S_P_CONTENTS) = iWork.Description
    End With
    
    nRow = nRow + 1
    
NEXT_WORK:
    Call iWork.Increment
  Loop
End Function
