Attribute VB_Name = "z_UIMessages"
' Messaging module
Option Private Module
Option Explicit

Public Enum MsgCode
  EM_PROJECTS_EMPTY
  EM_INPUT_INVALID_YEAR
  EM_INVALID_REPORT_TEMPLATE
  EM_CANNOT_ACCESS_PROJECTS
  EM_ADD_YEAR_NO_ACCESS
  EM_CANNOT_ACCESS_SAMPLES
  EM_DAILY_NO_WORKS
  EM_CANNOT_CREATE_MAIL
  
  IM_UPDATE_PIVOT_OK
  IM_MONTH_REPORT_OK
  IM_ADD_YEAR_AUTO
  IM_ADD_YEAR_MANUAL
  IM_HOLIDAYS_DELETED
End Enum

Private g_UI As API_UserInteraction

Public Function UserInteraction() As API_UserInteraction
  If g_UI Is Nothing Then _
    Set g_UI = New API_UserInteraction
  Set UserInteraction = g_UI
End Function

Public Function SetUserInteraction(newUI As API_UserInteraction)
  Set g_UI = newUI
End Function

Public Function UIShowMessage(theCode As MsgCode, ParamArray params() As Variant)
  Dim unwrapped As Variant: unwrapped = params
  unwrapped = FixForwardedParams(unwrapped)
  
  Select Case theCode
  Case IM_UPDATE_PIVOT_OK:            Call MsgBox("  ", vbInformation)
  Case IM_MONTH_REPORT_OK:            Call MsgBox("  ", vbInformation)
  Case IM_HOLIDAYS_DELETED:           Call MsgBox(Fmt(" : {1}", unwrapped), vbInformation)
  Case IM_ADD_YEAR_AUTO:              Call MsgBox("    " & _
                                                  vbNewLine & "     ", vbInformation)
  Case IM_ADD_YEAR_MANUAL:            Call MsgBox("    " & _
                                                  vbNewLine & "!     ", vbInformation)
  
  Case EM_PROJECTS_EMPTY:             Call MsgBox("  ", vbExclamation)
  Case EM_INPUT_INVALID_YEAR:         Call MsgBox("   ", vbExclamation)
  Case EM_INVALID_REPORT_TEMPLATE:    Call MsgBox("     ", vbExclamation)
  Case EM_CANNOT_ACCESS_PROJECTS:     Call MsgBox(Fmt("      " & vbNewLine & "{1}", unwrapped), vbExclamation)
  Case EM_CANNOT_ACCESS_SAMPLES:      Call MsgBox(Fmt("      " & vbNewLine & "{1}", unwrapped), vbExclamation)
  Case EM_ADD_YEAR_NO_ACCESS:         Call MsgBox(Fmt("      " & vbNewLine & "{1}", unwrapped), vbExclamation)
  Case EM_DAILY_NO_WORKS:             Call MsgBox("   ", vbExclamation)
  Case EM_CANNOT_CREATE_MAIL:         Call MsgBox("     Outlook", vbExclamation)
  
  Case Else:                          Call MsgBox("  ", vbCritical)
  End Select
End Function

Public Function UIAskQuestion(theCode As MsgCode, ParamArray params() As Variant) As Boolean
  Dim unwrapped As Variant: unwrapped = params
  unwrapped = FixForwardedParams(unwrapped)
  
  Dim answer&: answer = vbNo
  Select Case theCode
  'Case QM_CODE_DELETE_CONFIRM
  '  answer = MsgBox("Are you sure you want to delete ALL macros from target file?", vbYesNo + vbQuestion)
    
  Case Else
    Call MsgBox("  ", vbCritical)
  End Select
  UIAskQuestion = answer = vbYes
End Function
